<template>
  <div class="file-upload-container">
    <v-btn
      class="ma-2"
      color="#30488b"
      style="color: #f4f4f8"
      small
      depressed
      @click="show = true"
    >
      Importo
      <v-icon right dark small>
        mdi-file-upload
      </v-icon>
    </v-btn>
    <v-dialog v-model="show" width="500">
      <v-card>
        <v-card-title class="headline text-center lighten-2" primary-title>
          Importo {{ label }}
        </v-card-title>
        <v-file-input
          class="file-upload-sales ma-6"
          accept=".csv, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
          :label="inputLabel"
          @change="selectFile"
        />

        <v-card-actions class="lighten-2">
          <v-btn text color="primary" @click="downloadTemplate"
            >Download Template</v-btn
          >
          <v-spacer />
          <v-btn
            color="blue-grey"
            class="ma-2 white--text"
            small
            :loading="loading"
            :disabled="loading"
            @click="uploadFile"
          >
            Ngarkoni File
            <v-icon right dark>mdi-cloud-upload</v-icon>
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <toast
      @toastUpdated="showNotification = false"
      :type="type"
      :message="message"
      :snackbar="showNotification"
    >
      {{ message }}
    </toast>
  </div>
</template>
<script lang="ts">
import Vue from 'vue'
import api from '../../plugins/api'
import Toast from '../toasts/Toast.vue'

import { Component, Prop } from 'vue-property-decorator'

@Component({
  components: { Toast },
})
export default class FileUpload extends Vue {
  @Prop({ type: String, required: true }) api
  @Prop({ type: String, required: true }) downloadApi
  @Prop({ type: String, default: '' }) label
  @Prop({ type: String, default: 'Zgjidh' }) inputLabel

  show = false
  loading = false
  file = ''
  type = ''
  message = ''
  showNotification = false

  selectFile(event) {
    this.file = event
  }
  async uploadFile() {
    this.loading = true
    try {
      const formData = new FormData()
      formData.append('file', this.file)

      const response = await api().post(`${this.api}`, formData)
      this.showNotification = true
      this.message = response.data.message
      if (!response || response.data.status !== 0) {
        return (this.type = 'error')
      }
      this.type = 'success'
      this.show = false
      this.$root.$emit('file-uploaded')
    } catch {
      this.showNotification = true
      this.message = 'Ndodhi një problem'
      this.type = 'error'
    } finally {
      this.loading = false
    }
  }
  downloadTemplate() {
    const parentLocation = document.referrer.split('/')[2] || ''
    window.open(
      window.location.protocol + `//${parentLocation}/${this.downloadApi}`
    )
  }
}
</script>
